| OpendTect 8.0

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
Survey::Geometry2D Class Reference
Basic

Geometry of a 2D Line. More...

`#include <survgeom2d.h>`

Inheritance diagram for Survey::Geometry2D:
[legend]

## Public Member Functions
| Geometry2D (const char *lnm)
| Geometry2D (PosInfo::Line2DData *)
| Line2DData becomes mine.
void | add (const Coord &, int trcnr, float spnr)
void | add (double x, double y, int trcnr, float spnr)
Geometry2D * | as2D () override
float | averageTrcDist () const override
RelationType | compare (const Geometry &, bool usezrg) const override
const PosInfo::Line2DData & | data () const
PosInfo::Line2DData & | dataAdmin ()
| If data is changed, call touch afterwards.
const char * | getName () const override
bool | getPosByCoord (const Coord &, int &trc, float &sp) const
bool | getPosBySPNr (float spnr, Coord &, int &trcnr) const
bool | getPosByTrcNr (int trcnr, Coord &, float &spnr) const
bool | includes (int linenr, int tracenr) const override
bool | is2D () const override
bool | isEmpty () const
float | lineLength () const
TrcKey | nearestTrace (const Coord &, float *dist) const override
void | setAverageTrcDist (float)
void | setEmpty ()
void | setLineLength (float)
int | size () const
TypeSet< float > & | spnrs ()
const TypeSet< float > & | spnrs () const
Coord | toCoord (int linenr, int tracenr) const override
Coord | toCoord (int tracenr) const
void | touch ()
StepInterval< float > | zRange () const
Public Member Functions inherited from Survey::Geometry
const Geometry2D * | as2D () const
virtual Geometry3D * | as3D ()
const Geometry3D * | as3D () const
OD::GeomSystem | geomSystem () const
Pos::GeomID | getID () const
OD::GeomSystem | getSurvID () const
virtual TrcKey | getTrace (const Coord &, float maxdist) const
bool | includes (const BinID &b) const
bool | includes (const TrcKey &) const
virtual bool | includes (Pos::LineID, Pos::TraceID) const =0
const TrcKeyZSampling & | sampling () const
void | setID (const Pos::GeomID &id)
Coord | toCoord (const BinID &b) const
virtual Coord | toCoord (Pos::LineID, Pos::TraceID) const =0
Public Member Functions inherited from RefCount::Referenced
void | addObserver (WeakPtrBase *obs)
| Not for normal use. May become private.
int | nrRefs () const
| Only for expert use.
void | ref () const
bool | refIfReffed () const
| Don't use in production, for debugging.
void | removeObserver (WeakPtrBase *obs)
| Not for normal use. May become private.
bool | tryRef () const
| Not for normal use. May become private.
void | unRef () const
void | unRefNoDelete () const

## Static Public Member Functions
static BufferString | makeUniqueLineName (const char *lsnm, const char *lnm)
Static Public Member Functions inherited from Survey::Geometry
static const Geometry & | default3D ()
static bool | exists (const TrcKey &)
static Coord | toCoord (const TrcKey &)
Static Public Member Functions inherited from RefCount::Referenced
static bool | isSane (const Referenced *)

## Protected Member Functions
| ~Geometry2D ()
Protected Member Functions inherited from Survey::Geometry
| Geometry ()
virtual | ~Geometry ()
Protected Member Functions inherited from RefCount::Referenced
| Referenced ()
| Referenced (const Referenced &)
virtual | ~Referenced ()
Referenced & | operator= (const Referenced &)

## Protected Attributes
PosInfo::Line2DData & | data_
float | linelength_
Threads::Lock | lock_
TypeSet< float > | spnrs_
float | trcdist_
Protected Attributes inherited from Survey::Geometry
TrcKeyZSampling | sampling_

## Additional Inherited Members
Public Types inherited from Survey::Geometry
enum | RelationType { UnRelated =0 , Related , SubSet , SuperSet , Identical }

## Detailed Description

Geometry of a 2D Line.

<>

## Constructor & Destructor Documentation

## ◆ Geometry2D() [1/2]

Survey::Geometry2D::Geometry2D | ( | const char * | lnm | ) |

## ◆ Geometry2D() [2/2]

Survey::Geometry2D::Geometry2D | ( | PosInfo::Line2DData * |  | ) |

Line2DData becomes mine.

## ◆ ~Geometry2D()

Survey::Geometry2D::~Geometry2D | ( |  | ) |
| protected

## Member Function Documentation

## ◆ add() [1/2]

void Survey::Geometry2D::add | ( | const Coord & | ,
|  | int | trcnr,
|  | float | spnr )

## ◆ add() [2/2]

void Survey::Geometry2D::add | ( | double | x,
|  | double | y,
|  | int | trcnr,
|  | float | spnr )

## ◆ as2D()

Geometry2D * Survey::Geometry2D::as2D | ( |  | ) |
| inline override virtual

Reimplemented from Survey::Geometry.

## ◆ averageTrcDist()

float Survey::Geometry2D::averageTrcDist | ( |  | ) | const
| override virtual

Implements Survey::Geometry.

## ◆ compare()

RelationType Survey::Geometry2D::compare | ( | const Geometry & | ,
|  | bool | usezrg ) const
| override virtual

Reimplemented from Survey::Geometry.

## ◆ data()

const PosInfo::Line2DData & Survey::Geometry2D::data | ( |  | ) | const
| inline

## ◆ dataAdmin()

PosInfo::Line2DData & Survey::Geometry2D::dataAdmin | ( |  | ) |
| inline

If data is changed, call touch afterwards.

## ◆ getName()

const char * Survey::Geometry2D::getName | ( |  | ) | const
| override virtual

Implements Survey::Geometry.

## ◆ getPosByCoord()

bool Survey::Geometry2D::getPosByCoord | ( | const Coord & | ,
|  | int & | trc,
|  | float & | sp ) const

## ◆ getPosBySPNr()

bool Survey::Geometry2D::getPosBySPNr | ( | float | spnr,
|  | Coord & | ,
|  | int & | trcnr ) const

## ◆ getPosByTrcNr()

bool Survey::Geometry2D::getPosByTrcNr | ( | int | trcnr,
|  | Coord & | ,
|  | float & | spnr ) const

## ◆ includes()

bool Survey::Geometry2D::includes | ( | int | linenr,
|  | int | tracenr ) const
| override

## ◆ is2D()

bool Survey::Geometry2D::is2D | ( |  | ) | const
| inline override virtual

Implements Survey::Geometry.

## ◆ isEmpty()

bool Survey::Geometry2D::isEmpty | ( |  | ) | const

## ◆ lineLength()

float Survey::Geometry2D::lineLength | ( |  | ) | const

## ◆ makeUniqueLineName()

static BufferString Survey::Geometry2D::makeUniqueLineName | ( | const char * | lsnm,
|  | const char * | lnm )
| static

## ◆ nearestTrace()

TrcKey Survey::Geometry2D::nearestTrace | ( | const Coord & | ,
|  | float * | dist ) const
| override virtual

Implements Survey::Geometry.

## ◆ setAverageTrcDist()

void Survey::Geometry2D::setAverageTrcDist | ( | float |  | ) |

## ◆ setEmpty()

void Survey::Geometry2D::setEmpty | ( |  | ) |

## ◆ setLineLength()

void Survey::Geometry2D::setLineLength | ( | float |  | ) |

## ◆ size()

int Survey::Geometry2D::size | ( |  | ) | const

## ◆ spnrs() [1/2]

TypeSet< float > & Survey::Geometry2D::spnrs | ( |  | ) |
| inline

## ◆ spnrs() [2/2]

const TypeSet< float > & Survey::Geometry2D::spnrs | ( |  | ) | const
| inline

## ◆ toCoord() [1/2]

Coord Survey::Geometry2D::toCoord | ( | int | linenr,
|  | int | tracenr ) const
| override

## ◆ toCoord() [2/2]

Coord Survey::Geometry2D::toCoord | ( | int | tracenr | ) | const

## ◆ touch()

void Survey::Geometry2D::touch | ( |  | ) |

## ◆ zRange()

StepInterval< float > Survey::Geometry2D::zRange | ( |  | ) | const

## Member Data Documentation

## ◆ data_

PosInfo::Line2DData& Survey::Geometry2D::data_
| protected

## ◆ linelength_

float Survey::Geometry2D::linelength_
| mutable protected

## ◆ lock_

Threads::Lock Survey::Geometry2D::lock_
| mutable protected

## ◆ spnrs_

TypeSet<float> Survey::Geometry2D::spnrs_
| protected

## ◆ trcdist_

float Survey::Geometry2D::trcdist_
| mutable protected

Generated at
for the OpendTect seismic interpretation project. Copyright (C): dGB Beheer B.V. 1995-2025